// ==============================================================
//
//  Copyright (c) 1999-2004 by Alex Vinokur.
//
//  For conditions of distribution and use, see
//  copyright notice in version.h
//
// ==============================================================


// ##############################################################
// ==================================
//  n-ary Huffman Template Algorithm
// ==================================
//
//  FILE : raw.cpp
//
//  AUTHOR : Alex Vinokur
//
//  DESCRIPTION :
//
//
//         Treatment of raw frequencies (Implementation)
//         ---------------------------------------------
//
// ##############################################################

// ==============
#include "raw2.h"
// ==============

// ------------------------
int usage_help (int argc, char **argv)
{
  assert (argc == 1);

  cout << endl;
  cout << ""
       << "USAGE : " 
       << argv[0]
       << " <source files> "
       << "[ "
       << END_OF_TEXT_FILE_ARGV
       << " <message files>"
       << " ]"
       << endl;
       
  cout << endl;
  cout << ""
       << "Note : " 
       << endl
       << "      Source files  is to be used to get frequencies"
       << endl
       << "      Message files is to be encoded"
       << endl;


  cout << endl;
  cout << endl;
  cout << ""
       << "EXAMPLES : " 
       << endl
       << "\t"
       << argv[0]
       << " aaa.txt bbb.src ccc ddd.dat "
       << endl
       << "\t"
       << argv[0]
       << " aaa.txt bbb.src ccc ddd.dat "
       << END_OF_TEXT_FILE_ARGV
       << " xxx.txt yyy.msg zzz"
       << endl;


  return 0;
}



// -----------
ostream& operator<< (ostream& o, const AuxPairSymbolCode& inst_i)
{
  return o << "(" 
           << inst_i.ext_symbol_
           << ", " 
           << gstr_vector (inst_i.code_path_)
           << ") ";
}


// ----------- class lessAuxPairSymbolCode -----------
bool lessAuxPairSymbolCode::operator()(
                        const AuxPairSymbolCode& inst1_i,
                        const AuxPairSymbolCode& inst2_i
                        )
{
  if (inst1_i.code_path_.size() < inst2_i.code_path_.size()) return true;   
  if (inst2_i.code_path_.size() < inst1_i.code_path_.size()) return false;   
  assert (inst1_i.code_path_.size() == inst2_i.code_path_.size());   

  if (inst1_i.ext_symbol_.size() > inst2_i.ext_symbol_.size()) return true;
  if (inst2_i.ext_symbol_.size() > inst1_i.ext_symbol_.size()) return false;
  assert (inst1_i.ext_symbol_.size() == inst2_i.ext_symbol_.size());   

  return false;
     
}


